
#ifndef _MATRIX_H
#define _MATRIX_H

#include <stdbool.h>

#ifdef GFX_SDL
#include <SDL/SDL.h>
#endif

struct matrix;
typedef struct matrix matrix;

void mtrx_free(matrix **);
void mtrx_fill(matrix *);
void mtrx_clone_data(const matrix *, matrix *);
void mtrx_init(matrix **, int width, int height);
unsigned int mtrx_width(const matrix *);
unsigned int mtrx_height(const matrix *);
bool is_set(const matrix * m, unsigned int, unsigned int);
void set(matrix *, unsigned int, unsigned int);
void unset(matrix *, unsigned int, unsigned int);
int mtrx_cmp(matrix *, matrix *);

#ifdef GFX_SDL
SDL_Surface *create_sdl_surface(matrix *);
#endif

#endif
